<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Installation</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="install">Installation </a></h1><hr/>
<p>Sections:</p>
<ul>
<li><a class="el" href="install.html#c_config">Configuration</a></li>
<li><a class="el" href="install.html#c_autoinst">Automated Installation</a></li>
<li><a class="el" href="install.html#c_maninst">Manual Installation</a></li>
<li><a class="el" href="install.html#c_atlas">ATLAS</a></li>
<li><a class="el" href="install.html#c_lapack">LAPACK</a></li>
<li><a class="el" href="install.html#c_mpi">MPI</a></li>
<li><a class="el" href="install.html#c_mpich2">MPICH2</a></li>
<li><a class="el" href="install.html#c_metis">ParMetis</a></li>
<li><a class="el" href="install.html#c_sundials">SUNDIALS</a></li>
<li><a class="el" href="install.html#c_petsc">PETSc</a></li>
<li><a class="el" href="install.html#c_tao">TAO</a></li>
<li><a class="el" href="install.html#c_zlib">zlib</a></li>
<li><a class="el" href="install.html#c_libpng">libpng</a></li>
<li><a class="el" href="install.html#c_magpar">magpar</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="c_config">
Configuration</a></h2>
<p>Create a directory, which will contain all libraries, source code, tools, and documentation for magpar, and set the environment variable MAGPAR_HOME: </p>
<div class="fragment"><pre class="fragment">
  # change into any directory, where you want to install magpar
  # for example in your $HOME/work directory
  cd $HOME; mkdir work; cd work
  # download the magpar source archive by hand or using wget:
  lib=magpar
  wget http://www.magpar.net/$lib/download/$lib.tar.gz
  # unpack the archive
  tar xzvf $lib.tar.gz
  cd $lib
  MAGPAR_HOME=$PWD; export MAGPAR_HOME   # sh/bash syntax (use "setenv" for csh)
  PD=$MAGPAR_HOME/libs; export PD
</pre></div><p>If you are upgrading from a previous version of magpar, you can usually reuse the libraries, which you have already compiled and installed. However, please note the <a class="el" href="changes.html">ChangeLog</a> and upgrade libraries as required or recommended.</p>
<p>The current version of magpar has been developed and tested with the configuration and library versions defined in <a class="el" href="makefiles.html#makefiles_Makefile_in_defaults">Makefile.in.defaults</a> .</p>
<p>Links to the websites of the libraries can be found in the list of <a class="el" href="required.html">Required Software</a>.</p>
<hr/>
<p>Create Makefile.in.$HOSTNAME using <a class="el" href="makefiles.html#makefiles_Makefile_in_defaults">Makefile.in.defaults</a> (or one of the other Makefile.in.host_*): </p>
<div class="fragment"><pre class="fragment">
  cp Makefile.in.defaults Makefile.in.$HOSTNAME
</pre></div><p> and edit it:</p>
<ul>
<li>set paths</li>
<li>(de)activate libraries, set/override library versions (see <a class="el" href="makefiles.html#makefiles_Makefile_in_host_oldlibs">Makefile.in.host_oldlibs</a>)</li>
<li>set compiler flags for optimization</li>
</ul>
<p>It should not be necessary to modify <a class="el" href="makefiles.html#makefiles_Makefile">Makefile</a> or <a class="el" href="makefiles.html#makefiles_Makefile_in">Makefile.in</a> at all any more!</p>
<p>Please refer to the <a class="el" href="faq.html">FAQ</a> for tips and suggestions for the installation of magpar on specific systems and software environments.</p>
<hr/>
<h2><a class="anchor" id="c_autoinst">
Automated Installation</a></h2>
<p>The (manual) installation procedures described below are now conveniently combined in <a class="el" href="makefiles.html#makefiles_Makefile_libs">Makefile.libs</a> .</p>
<p>Just simply do </p>
<div class="fragment"><pre class="fragment">
  cd $MAGPAR_HOME/src
  make -f Makefile.libs
</pre></div><p>All libraries will be downloaded automatically using "wget", configured, compiled, and installed in $PD in the following order:</p>
<div class="fragment"><pre class="fragment">
  atlas lapack mpi parmetis sundials petsc tao zlib libpng
</pre></div><p>It is also possible to install the libraries one at a time like this (e.g. PETSc) </p>
<div class="fragment"><pre class="fragment">
  cd $MAGPAR_HOME/src
  make -f Makefile.libs petsc
</pre></div><p> using the names listed above. This makes it easier to use precompiled packages (e.g. <a class="el" href="faq.html#debpack">Precompiled packages on Ubuntu/Debian</a>) and then just install the remaining ones with the convenience of using <a class="el" href="makefiles.html#makefiles_Makefile_libs">Makefile.libs</a> .</p>
<p>If this does not work, then please follow the manual installation instructions below.</p>
<p>Once all libraries are compiled and installed, compile <a class="el" href="install.html#c_magpar">magpar</a> as described below.</p>
<hr/>
<h2><a class="anchor" id="c_maninst">
Manual Installation</a></h2>
<p>Check for <a class="el" href="required.html">Required Software</a> which is already preinstalled on your machine. For example, there are <a class="el" href="faq.html#debpack">Precompiled packages on Ubuntu/Debian</a> available. Download, unpack, compile and install all other required libraries in the order given below in the directory $PD. Some libraries are optional,and only required if you want to try different linear solvers (e.g. hypre, SuperLU). It is highly recommended to use any machine specific (vendor provided and highly optimized) libraries. On most high performance machines there are optimized BLAS, LAPACK, and MPI libraries available (cf. <a class="el" href="faq.html">FAQ</a> : <a class="el" href="faq.html#optblas">Optimized BLAS libraries</a>). In this case you just have to set the paths to your libraries properly, when you configure and compile various packages.</p>
<p>If you have trouble installing any of the required libraries, please check their respective installation guides/documentation/FAQs/website first. The URLs of their websites can be found on the <a class="el" href="required.html">Required Software</a> page.</p>
<hr/>
<h2><a class="anchor" id="c_atlas">
ATLAS</a></h2>
<p>For your convenience get one of the binary packages for your hardware platform from the stable branch of <a href="http://sourceforge.net/projects/math-atlas/">ATLAS</a> (unless you do already have <a class="el" href="faq.html#optblas">Optimized BLAS libraries</a>).</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  # set lib with the name of your ATLAS library
  lib=atlas3.6.0_Linux_PIIISSE1.tar.gz
  tar xzvf $lib
  # create a symbolic link to the directory with the ATLAS binaries:
  ln -s Linux_* atlas
  lapacklib=$PD/atlas/lib/liblapack.a
  # rename (incomplete) lapack library provided by ATLAS (cf. LAPACK below)
  mv $lapacklib $lapacklib.atlas
</pre></div><hr/>
<h2><a class="anchor" id="c_lapack">
LAPACK</a></h2>
<p>Debian, RedHat and other distributors provide precompiled binaries of LAPACK. Try the <a class="el" href="faq.html#debpack">Precompiled packages on Ubuntu/Debian</a> or check the web for availablility. <br/>
 <a href="http://www.debian.org/distrib/packages">http://www.debian.org/distrib/packages</a> <br/>
 <a href="http://rpmfind.net/">http://rpmfind.net/</a> <br/>
 <a href="http://www.redhat.com/">http://www.redhat.com/</a> <br/>
 You may also recompile it from source:</p>
<div class="fragment"><pre class="fragment">
  # set Fortran compiler
  # GNU GCC &gt;=4.0 Fortran 77/95: gfortran
  FC=gfortran; TIMER=INT_ETIME
  #
  # GNU GCC &lt; 4.0 Fortran 77:    g77
  #FC=g77; TIMER=EXT_ETIME
  #
  # check that Fortran compiler works
  $FC --version
  #
  cd $PD
  lib=lapack.tgz
  wget http://www.netlib.org/lapack/$lib
  tar xzvf $lib
  cd lapack-*
  cp INSTALL/make.inc.LINUX make.inc
  #
  # add CPU specific options to OPTS, e.g. -march=pentium4 -msse2 (cf. man gcc)
  # set correct Fortran compiler (check additional options in make.inc!):
  make "FORTRAN=$FC" "LOADER=$FC" \
  "TIMER=$TIMER" \
  "BLASLIB=$PD/atlas/lib/libf77blas.a $PD/atlas/lib/libatlas.a" \
  "OPTS=-funroll-all-loops -O3 $OOPTS" \
  lapacklib
  #
  # run tests (optional)
  make lapack_testing
</pre></div><p>Now we have to add the missing LAPACK functions to the ATLAS library: <br/>
 (cf. $PD/atlas/README, <a href="http://math-atlas.sourceforge.net/errata.html#completelp">Building a complete LAPACK library</a>)</p>
<div class="fragment"><pre class="fragment">
  cd $PD/atlas/lib
  cp $lapacklib.atlas $lapacklib
  mkdir tmp; cd tmp
  ar x $PD/lapack-*/lapack_LINUX.a
  ar r ../liblapack.a *.o
  cd ..; rm -rf tmp
</pre></div><hr/>
<h2><a class="anchor" id="c_mpi">
MPI</a></h2>
<p>MPICH, OpenMPI, LAM/MPI, or any other MPI library, which implements the <a href="http://www.mcs.anl.gov/research/projects/mpi/">MPI standard</a> (version 1 or 2) may be used.</p>
<p>You need rsh (recommended) or ssh to be installed and configured properly! Don't forget to create a ".rhosts" file with the names of all machines (also your local machine!) in your home directory (cf. "man rhosts"). The configuration can be tested with "rsh $HOSTNAME uname -a". You may also use ssh for encrypted communication between processors.</p>
<p>The directory $PD/mpi/bin should be added to the $PATH variable. Update your login scripts, e.g. .bashrc, .login, .profile, to make this permanent by appending the following code snippet:</p>
<div class="fragment"><pre class="fragment">
  PATH=$PD/mpi/bin:$PATH
  export PATH
</pre></div><p>or the programs installed in $PD/mpi/bin should be copied to $HOME/bin or any other directory within your $PATH, so that mpirun and other MPI tools can be called from the command line.</p>
<h3><a class="anchor" id="c_mpich2">
MPICH2</a></h3>
<p>If ssh should be used instead of rsh for login on remote machines use "./configure -rsh=ssh" when compiling MPICH. In this case public key authentication should be configured for ssh to enable login without passwords (cf. "man ssh").</p>
<p>The configure-script of MPICH will try both, rsh and ssh, and print a warning if neither service is configured properly.</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=mpich2.tar.gz
  wget -N --retr-symlinks ftp://ftp.mcs.anl.gov/pub/mpi/$lib
  # better download the latest version from
  # http://www.mcs.anl.gov/research/projects/mpich2/
  tar xzvf $lib
  #
  # change into mpich2 subdirectory (adjust to the downloaded version)
  cd mpich2-*
  #
  # use "ssm" (sockets and shared memory) for use on clusters of SMPs
  # (communication on the same machine goes through shared memory;
  # communication between different machines goes over sockets)
  # instead of default "sock"
  ./configure --prefix=$PD/mpich2 --with-device=ch3:ssm 2&gt;&amp;1 | tee configure.log
  #
  make -j 1 2&gt;&amp;1 | tee make.log
  make install 2&gt;&amp;1 | tee install.log
  #
  # set symbolic link to MPICH installation directory
  ln -s mpich2 $PD/mpi
  #
  # Please refer to $PD/mpi/README or
  # $PD/mpi/doc on how to use MPICH2 and
  # start a ring of MPI's process managers mpd!
</pre></div><p>Installation instructions for <a class="el" href="faq.html#c_mpich1">MPICH1</a> and <a class="el" href="faq.html#c_lam">LAM/MPI</a> have been moved to the <a class="el" href="faq.html">FAQ</a>.</p>
<hr/>
<h2><a class="anchor" id="c_metis">
ParMetis</a></h2>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=ParMetis-3.1.1
  wget -N http://glaros.dtc.umn.edu/gkhome/fetch/sw/parmetis/$lib.tar.gz
  tar xzvf $lib
  cd $lib
  make "CC=$PD/mpi/bin/mpicc" "LD=$PD/mpi/bin/mpicc"
  #
  # run tests (optional)
  cd Graphs
  $PD/mpi/bin/mpirun -np 4 ptest rotor.graph
  # more tests in ParMetis-3.1.1/INSTALL
</pre></div><hr/>
<h2><a class="anchor" id="c_sundials">
SUNDIALS</a></h2>
<p>(SUNDIALS version 2.3.0)</p>
<p>Download the library from the <a href="http://www.llnl.gov/CASC/sundials/download/download.html">SUNDIALS website</a> (registration required).</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=sundials-2.3.0
  tar xzvf $lib.tar.gz
  cd $(PD)/$lib
  # set compiler options (modify for your setup!)
  # add CPU specific options, e.g. -march=pentium4 -msse2 (cf. man gcc)
  CFLAGS="-O3"
  export CFLAGS
  ./configure --prefix=$PD/$lib --with-mpi-root=$PD/mpi
  make &amp;&amp; make -i install
  # (generates static libraries and installs libraries and include files
  # in $PD/$lib/libs and $PD/$lib/include)
</pre></div><hr/>
<h2><a class="anchor" id="c_petsc">
PETSc</a></h2>
<p>(PETSc version 2.3.0 and later)</p>
<p>Starting with PETSc version 2.3.0 you have to use the automatic Python-based configure system, which requires Python 2.2 or later. Please refer to the FAQ <a class="el" href="faq.html#pythoninst">Installing Python</a> if you need to install Python by hand.</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=petsc-2.3.3-p15
  wget ftp://ftp.mcs.anl.gov/pub/petsc/release-snapshots/$lib.tar.gz
  tar xzvf $lib.tar.gz
  cd $lib
  #
  # set environment variables
  # (here: bash style - use "setenv" in sh/csh)
  #
  PETSC_DIR=$PD/$lib
  export PETSC_DIR
  PETSC_ARCH=PETSc-config-magpar
  export PETSC_ARCH
  PRECISION=double
  export PRECISION
  #
  # edit PETSc-config-magpar.py
  # (select MPI, optional libraries, optimization options, etc.)
  # use the templates in $PETSC_DIR/config/ for platforms other than Linux
  # copy PETSc configuration script
  # (needs to be a copy - must not be a symbolic link!)
  #
  cp $MAGPAR_HOME/src/PETSc-config-magpar.py $PETSC_DIR/config/
  #
  # Run
  # ./config/configure.py --help
  # to see all command line options for configure.py.
  #
  # for static binaries edit
  # $PETSC_DIR/bmake/PETSc-config-magpar/petscconf (recommended):
  # remove all occurences of "-lgcc_s" and add "-static" to the linker flags:
  # CC_LINKER_FLAGS =   -Wall -O3 -static
  #
  ./config/PETSc-config-magpar.py
  make all
  #
  # run tests (optional)
  make test
</pre></div><p>Also refer to the <a href="http://www.mcs.anl.gov/petsc/petsc-as/documentation/installation.html">installation instructions</a> on the PETSc homepage!</p>
<hr/>
<h2><a class="anchor" id="c_tao">
TAO</a></h2>
<p>magpar requires<br/>
 (PETSc version 2.3.3 and TAO 1.9) (highly recommended) or<br/>
 (PETSc version 2.3.2 and TAO 1.8.2) or<br/>
 (PETSc version 2.3.0 and TAO 1.8) or<br/>
 (PETSc version 2.2.1 and TAO 1.7) or<br/>
 (PETSc version 2.2.0 and TAO 1.6)<br/>
 </p>
<div class="fragment"><pre class="fragment">
  lib=tao-1.9
  wget -N http://www.mcs.anl.gov/research/projects/tao/download/$lib
  tar xzvf $lib
  TAO_DIR=$PD/$lib; export TAO_DIR
  cd $TAO_DIR
  make
</pre></div><hr/>
<h2><a class="anchor" id="c_zlib">
zlib</a></h2>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=zlib-1.2.3
  wget -N http://downloads.sourceforge.net/libpng/$lib.tar.gz
  tar xzvf $lib.tar.gz
  ln -s $lib zlib
  cd $lib
  make CFLAGS="-O -fPIC" &amp;&amp; make test
</pre></div><hr/>
<h2><a class="anchor" id="c_libpng">
libpng</a></h2>
<div class="fragment"><pre class="fragment">
  cd $PD
  lib=libpng-1.2.33
  wget -N http://downloads.sourceforge.net/libpng/$lib.tar.gz?download
  tar xzvf $lib.tar.gz
  ln -s $lib libpng
  cd $lib
  instdir=$(PD)/$lib
  ./configure --prefix=$instdir --enable-shared=no 2&gt;&amp;1 | tee configure.log
  CFLAGS="-I$PD/zlib"; export CFLAGS
  LDFLAGS="-L$PD/zlib"; export LDFLAGS
  make 2&gt;&amp;1 | tee make.log
  make install 2&gt;&amp;1 | tee makeinst.log
  make check 2&gt;&amp;1 | tee makecheck.log
  # alternatively use the old method with a static Makefile:
  cp scripts/makefile.linux Makefile
  make ZLIBLIB=../zlib ZLIBINC=../zlib &amp;&amp; make test
</pre></div><hr/>
<h2><a class="anchor" id="c_magpar">
magpar</a></h2>
<p>Once all libraries are compiled and installed, compile magpar with</p>
<div class="fragment"><pre class="fragment">
  cd $MAGPAR_HOME/src
  make
</pre></div><p>If everything compiled (hopefully) ok, you should get the executable magpar.exe. </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

